<template>
    <div class="card shadow">
        <div class="card-body p-5 rounded-lg">
            <div class="progress mb-4 rounded-pill">
                <div class="progress-bar bg-success" role="progressbar" :style="{width: currentPage/lastPage*100 + '%'}" :aria-valuenow="currentPage/lastPage*100" aria-valuemin="0" aria-valuemax="100"></div>
            </div>
            <p class="font-weight-bold">Kuesioner Halaman {{ currentPage + '/' + lastPage }}</p>
            <h3 class="font-weight-bold text-green mb-0">Dari 2 pernyataan yang ada pada setiap nomor, pilih yang paling menggambarkan diri Anda.</h3>
            <hr class="my-5">
            <div>
                <loading :is-loading="isLoading"></loading>
                <form action="#" name="formQuestioner" class="form-questioner" @submit.prevent="submitAnswer()">
                    <div class="form-group form-row" :key="index" v-for="(questions, index) in questioner">
                        <div class="left-group col-lg-1">
                            <p class="font-weight-bold text-orange questioner-number">#{{ from + index }}</p>
                        </div>
                        <div class="right-group col-lg-11">
                            <div class="bg-light rounded-xl p-4">
                                <div class="custom-control custom-radio" :key="item.id" v-for="(item, i) in questions">
                                    <input type="radio" :id="`question-${item.id}`" :name="`question-${index}`" :value="item.id" class="custom-control-input" @change="selectRadio(index)" :required="i == 0">
                                    <label class="custom-control-label" :for="`question-${item.id}`">{{ item.name }}</label>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mt-4 text-center">
                        <button type="submit" class="btn btn-primary rounded-pill">Simpan Jawaban dan Lanjutkan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
import Loading from "./Loading";

export default {
    components: {
        'loading': Loading
    },
    data() {
        return {
            currentPage: 1,
            lastPage: 1,
            from: 1,
            questioner: [],
            isLoading: false,
            selected: [],
        }
    },
    created() {
        this.getQuestioner();
    },
    methods: {
        selectRadio(id) {
            // Simpan index soal kedalam array
            if ( this.selected.indexOf(id) === -1 ) {
                this.selected.push(id);
            }
        },
        getQuestioner() {
            this.isLoading = true;

            axios.get(`/fetch-questionnaire?page=${this.currentPage}`)
                .then( (res) => {
                    this.questioner = res.data.data;
                    this.from = res.data.from;
                    this.lastPage = res.data.last_page;
                    // add checked status
                    _.map(this.questioner, function(item) {
                        _.forEach(item, function(question) {
                            question['checked'] = false;
                        });
                    });
                    this.isLoading = false;
                    this.$scrollTo('body');
                });
        },
        submitAnswer() {
            this.isLoading = true;

            let selectedAnswer = [];
            let answer = {
                last_page: this.currentPage == this.lastPage,
                data: []
            };

            let form = document.forms.namedItem('formQuestioner');
            let formdata = new FormData(form);

            // Passing FormData value to Array
            for (let value of formdata.values()) {
                selectedAnswer.push(parseFloat(value));
            }

            _.forEach(this.questioner, (item) => {
                _.forEach(item, (quest) => {
                    answer.data.push({
                        id: quest.id,
                        checked: selectedAnswer.indexOf(quest.id) > -1 ? true : false,
                    });
                })
            });

            axios.post('/send-answer', { data: JSON.stringify(answer) },
                    {
                        headers: {
                            'content-type': 'application/json'
                        },
                    }
                )
                .then( (res) => {
                    if (res.data.redirect) {
                        location.href = res.data.url;
                    }
                    else {
                        this.isLoading = false;
                        this.currentPage = this.currentPage + 1;
                        this.getQuestioner();
                    }
                });
        }
    }
}
</script>
